//+------------------------------------------------------------------+
//|                                                                  |
//| conversion of beyazfils metatstock forumala to metatrader        |
//| formula :                                                        |
//|         ((MACD()-Tema(C,14))/Mov(C,15,S))-(MACD()*Mov(C, 15,S))  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2
#property indicator_level1 -1

//
//
//
//
//

extern int MACDFastPeriod = 12;
extern int MACDSlowPeriod = 26;
extern int MACDPrice      = PRICE_CLOSE;
extern int MAPeriod       = 15;
extern int MAMethod       = MODE_SMA;
extern int MAPrice        = PRICE_CLOSE;
extern int TEMAPeriod     = 14;
extern int TEMAPrice      = PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double emat[][3];
double alpha;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
      alpha = 2.0/(1.0 + TEMAPeriod);
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
              
   for(i=limit; i>=0; i--)
   {
      double macd = iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,1,MACDPrice,MODE_MAIN,i);
      double ma   = iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);
      double tema = iTema(emat,iMA(NULL,0,1,0,MODE_SMA,TEMAPrice,i),i);
         if (ma !=0)
             buffer1[i] = (macd-tema)/ma - macd*ma;
   }
   return(0);
}

//
//
//
//
//

double iTema(double& emas[][3],double price,int shift)
{
   int i = Bars-shift-1;
   
   if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
   if (i < 1)
      {
         emas[i][0] = price;
         emas[i][1] = price;
         emas[i][2] = price;
      }
   else
      {
         emas[i][0] = emas[i-1][0]+alpha*(price     -emas[i-1][0]);
         emas[i][1] = emas[i-1][1]+alpha*(emas[i][0]-emas[i-1][1]);
         emas[i][2] = emas[i-1][2]+alpha*(emas[i][1]-emas[i-1][2]);
      }
   return(3*emas[i][0] - 3*emas[i][1] + emas[i][2]);
}